package inheritance;

public class ShapeUser {
    public static void main(String[] args) {
        Rectangle r = new Rectangle(5.0, 10.0);
        Square s = new Square(3.0);

        useRect(r);
        useSquare(s);

        useRect(s);
    }

    // Can we use the rectangle here? Only some rectangles are squares!
    public static void useSquare(Square sq) {
        System.out.println(sq.area());
    }

    // Can we use the square here? Squares are rectangles!
    public static void useRect(Rectangle rect) {
        System.out.println(rect.area());
    }

    public static void useShape(Shape shape) {
        System.out.println(shape.area());
    }
}
