package generics;

import inheritance.Rectangle;
import inheritance.Shape;
import inheritance.Square;

public class BoxUser {
    public static void main(String[] args) {
        /*
         * Let's apply our generic box to store some Rectangles and Shapes and explore their relationship
         */

        // if the generic is on the left-hand side <> let's the compiler infer the type
        Box<Integer> intBox = new Box<>(); // = new Box<Integer>();
        Box<Rectangle> rectBox = new Box<>();
        Box<Square> sqBox = new Box<>();
        Box<Shape> shapeBox = new Box<>();

         emptyRegularBox(shapeBox);
         emptyRectangleBox(...);
         emptyShapeBox();
    }

    public static void emptyRegularBox(Box<?> box) {
        box.empty();
    }

    public static void emptyRectangleBox(Box<Rectangle> box) {
        box.empty();
    }

    public static void emptyShapeBox(Box<Shape> box) {
        box.empty();
    }
}
